DECLARE
   TYPE clientele IS TABLE OF VARCHAR2 (64);

   client_list_12    clientele := clientele ('Customer 1', 'Customer 2');
   client_list_13    clientele := clientele ('Customer 1', 'Customer 3');
   client_list_31    clientele := clientele ('Customer 3', 'Customer 1');
   --
   client_list_133    clientele := clientele ('Customer 1', 'Customer 3', 'Customer 3');
   --
   client_list_13n   clientele
                              := clientele ('Customer 1', 'Customer 3', NULL);
   client_list_3n1   clientele
                              := clientele ('Customer 3', NULL, 'Customer 1');

   PROCEDURE compare_clients (
      title_in      IN   VARCHAR2
    , clients1_in   IN   clientele
    , clients2_in   IN   clientele
   )
   IS
   BEGIN
      DBMS_OUTPUT.put_line (title_in);

      IF clients1_in = clients2_in
      THEN
         DBMS_OUTPUT.put_line ('   Client list 1 = Client list 2');
      ELSIF clients1_in != clients2_in
      THEN
         DBMS_OUTPUT.put_line ('   Client list 1 != Client list 2');
      ELSIF (clients1_in = clients2_in) IS NULL
      THEN
         DBMS_OUTPUT.put_line ('   NULL result');
      END IF;
   END compare_clients;
BEGIN
   compare_clients ('1,2 compared to 1,3', client_list_12, client_list_13);
   --
   compare_clients ('1,3 compared to 3,1', client_list_13, client_list_31);
   --
   compare_clients ('1,3,3 compared to 3,1', client_list_133, client_list_31);
   --
   compare_clients ('1,3,NULL compared to 3,NULL,1'
                  , client_list_13n
                  , client_list_3n1
                   );
   compare_clients ('1,3,NULL compared to 1,3,NULL'
                  , client_list_13n
                  , client_list_13n
                   );
END;
/
