SET SERVEROUTPUT ON FORMAT WRAPPED

DECLARE
   TYPE tab_bynum_tabtype IS TABLE OF employee%ROWTYPE
      INDEX BY BINARY_INTEGER;
	  
   TYPE tab_byvc_tabtype IS TABLE OF employee%ROWTYPE
      INDEX BY VARCHAR2(100);

   bynum_tab tab_bynum_tabtype;
   
   byvc_tab tab_byvc_tabtype;
   
   numtmr tmr_t := tmr_t.make ('By Num', 10000);
   vctmr tmr_t := tmr_t.make ('By VC', 10000);
   v_salary NUMBER;
BEGIN
   FOR rec IN  (SELECT *
                  FROM employee)
   LOOP
      bynum_tab (rec.employee_id) := rec;
   END LOOP;

   FOR rec IN  (SELECT *
                  FROM employee)
   LOOP
      byvc_tab (rec.last_name) := rec;
   END LOOP;

   numtmr.go;

   FOR indx IN 1 .. 10000
   LOOP
      FOR rec IN  (SELECT *
                     FROM employee)
      LOOP
         v_salary := bynum_tab (rec.employee_id).salary;
      END LOOP;
   END LOOP;

   numtmr.STOP;
   vctmr.go;

   FOR indx IN 1 .. 10000
   LOOP
      FOR rec IN  (SELECT *
                     FROM employee)
      LOOP
         v_salary := byvc_tab (rec.last_name).salary;
      END LOOP;
   END LOOP;

   vctmr.STOP;
END;
/
/*
Elapsed time for "By Num" = 27.45 seconds. Per repetition timing = .002745 seconds
Elapsed time for "By VC" = 27.82 seconds. Per repetition timing = .002782 seconds
*/
