DROP TABLE parts;

CREATE TABLE parts (
   partnum NUMBER,
   partname VARCHAR2(15)
   );
   
CREATE OR REPLACE PROCEDURE compare_deleting (num IN INTEGER)
IS
   TYPE NumTab IS TABLE OF parts.partnum%TYPE INDEX BY BINARY_INTEGER;
   TYPE NameTab IS TABLE OF parts.partname%TYPE INDEX BY BINARY_INTEGER;
   pnums NumTab;
   pnames NameTab;
BEGIN
   FOR indx IN 1..num LOOP
      pnums(indx) := indx;
      pnames(indx) := 'Part ' || TO_CHAR(indx);
   END LOOP;
   
   FOR indx IN 1..num LOOP
      INSERT INTO parts VALUES (pnums(indx), pnames(indx));
   END LOOP;
   COMMIT;
   
   PLVtmr.capture;
   FOR indx IN 1..num LOOP
      DELETE FROM parts WHERE partnum = pnums(indx);
   END LOOP;
   PLVtmr.show_elapsed ('FOR loop '|| num);
   
   ROLLBACK;
   
   PLVtmr.capture;
   FORALL indx IN 1..num 
      DELETE FROM parts WHERE partnum = pnums(indx);
  
   PLVtmr.show_elapsed ('FORALL '|| num);
   
   ROLLBACK;
END;
/
BEGIN
   compare_deleting (1000);
   compare_deleting (10000);
END;
/   