DROP TABLE stuff
/

CREATE TABLE stuff (pk INTEGER, description VARCHAR2(100))
/

BEGIN
   FOR indx IN 1 .. 107000
   LOOP
      INSERT INTO stuff
                  ( pk, description
                  )
           VALUES ( indx, 'Stuff ' || indx
                  );
   END LOOP;

   COMMIT;
END;
/

DECLARE
   CURSOR stuff_cur
   IS
      SELECT *
        FROM stuff;

   TYPE stuff_aat IS TABLE OF stuff%ROWTYPE
      INDEX BY BINARY_INTEGER;

   l_stuff stuff_aat;

   PROCEDURE process_one_row ( row_in IN stuff%ROWTYPE )
   IS
   BEGIN
      NULL;
   END;

   PROCEDURE show_status ( count_in IN PLS_INTEGER, notfound_in IN BOOLEAN )
   IS
   BEGIN
      IF notfound_in
      THEN
         DBMS_OUTPUT.put_line (    'Fetched '
                                || TO_CHAR ( count_in )
                                || ' rows and %NOTFOUND = TRUE'
                              );
      ELSIF NOT notfound_in
      THEN
         DBMS_OUTPUT.put_line (    'Fetched '
                                || TO_CHAR ( count_in )
                                || ' rows and %NOTFOUND = FALSE'
                              );
      ELSE
         DBMS_OUTPUT.put_line (    'Fetched '
                                || TO_CHAR ( count_in )
                                || ' rows and %NOTFOUND IS NULL'
                              );
      END IF;
   END show_status;
BEGIN
   OPEN stuff_cur;

   LOOP
      FETCH stuff_cur
      BULK COLLECT INTO l_stuff LIMIT 50000;

      show_status ( l_stuff.COUNT, stuff_cur%NOTFOUND );
      EXIT WHEN l_stuff.COUNT = 0;

      --
      FOR l_row IN l_stuff.FIRST .. l_stuff.LAST
      LOOP
         process_one_row ( l_stuff ( l_row ));
      END LOOP;
   END LOOP;

   CLOSE stuff_cur;
END;
/
