DECLARE
   TYPE employees_aat IS TABLE OF employees%ROWTYPE
      INDEX BY PLS_INTEGER;

   l_employees employees_aat;
BEGIN
   SELECT *
   BULK COLLECT INTO l_employees
     FROM employees;

   -- Delete just the first row.
   l_employees.DELETE ( l_employees.FIRST );
   --
   -- Delete all rows betten 7 and 20.
   l_employees.DELETE ( 7, 20 );

   --
   -- Delete all the even rows (!).
   FOR indx IN 1 .. l_employees.COUNT
   LOOP
      IF l_employees.EXISTS ( indx ) AND MOD ( indx, 2 ) = 0
      THEN
         l_employees.DELETE ( indx );
      END IF;
   END LOOP;

   --
   -- Delete all the remaining rows.
   l_employees.DELETE;
END;
/
