CREATE OR REPLACE FUNCTION betwnstr (
   string_in   IN   VARCHAR2
 , start_in    IN   INTEGER
 , end_in      IN   INTEGER
)
   RETURN VARCHAR2
IS
BEGIN
   DBMS_LOCK.sleep ( .05 );
   RETURN 'abc';
END;
/

BEGIN
   PLVtmr.capture;

   FOR rec IN ( SELECT betwnstr ( 'abc', 1, 5 )
                 FROM employees )
   LOOP
      NULL;
   END LOOP;

   PLVtmr.show_elapsed ( 'Non-Deterministic function in query' );
END;
/

CREATE OR REPLACE FUNCTION betwnstr (
   string_in   IN   VARCHAR2
 , start_in    IN   INTEGER
 , end_in      IN   INTEGER
)
   RETURN VARCHAR2 DETERMINISTIC
IS
BEGIN
   DBMS_LOCK.sleep ( .05 );
   RETURN 'abc';
END;
/

BEGIN
   PLVtmr.capture;

   FOR rec IN ( SELECT betwnstr ( 'abc', 1, 5 )
                 FROM employees )
   LOOP
      NULL;
   END LOOP;

   PLVtmr.show_elapsed ( 'Deterministic function in query' );
END;
/

DECLARE
   l_string VARCHAR2 ( 100 );
BEGIN
   PLVtmr.capture;

   FOR rec IN ( SELECT *
                 FROM employees )
   LOOP
      l_string := betwnstr ( 'abc', 1, 5 );
   END LOOP;

   PLVtmr.show_elapsed ( 'Deterministic function in block' );
END;
/
