DROP TABLE parts;

CREATE TABLE parts (
   partnum NUMBER,
   partname VARCHAR2(15)
   );

CREATE TYPE nums_t iS TABLE OF NUMBER;
/
CREATE TYPE names_t is TABLE OF VARCHAR2(100);
/
DECLARE
   dynstr VARCHAR2(2000);
   
   pnums nums_t := nums_t();
   pnames names_t := names_t();
BEGIN
   EXECUTE IMMEDIATE 'TRUNCATE TABLE parts';

   /* Load up the table. */
   FOR indx IN 1 .. 10000
   LOOP
      INSERT INTO parts
           VALUES (indx, 'Part ' || TO_CHAR (indx));
   END LOOP;

   COMMIT;
   
   dynstr :=
      'BEGIN
          SELECT * BULK COLLECT INTO :pnums, :pnames FROM parts;
       END;';
    
   EXECUTE IMMEDIATE dynstr USING  OUT pnums,  OUT pnames;
   p.l (pnums.COUNT);
END;
/
