-- =====================================================================
-- 
-- Description:  This code contains the procedures for allowing any 
--               plsql procedure to send email.  Must be run as a user
--		 with create any procedure privileges.  This method can
--		 only be used with Oracle 8.x since a library is created.
--
-- ---------------- Modification History -----------
-- Programmer           Date            Description
-- ------------------   ----------      ------------------------
-- Bob Rudolf           04/15/99        Creation
--
--
-- ======================================================================

CREATE OR REPLACE LIBRARY EMAIL AS 'C:\INETPUB\WWWROOT\INTERNET\ORACLE\MAILTEST.DLL'

CREATE OR REPLACE procedure EMAILER
	(V IN OUT VARCHAR2,
 	W IN OUT VARCHAR2,
 	X IN OUT VARCHAR2,
 	Y IN OUT VARCHAR2,
 	Z IN OUT VARCHAR2)
 AS
 external  library EMAIL
 name "EMailer" 		-- EMailer is the name of function in the MAILTEST.DLL
 PARAMETERS(V STRING,
 W STRING,
 X STRING,
 Y STRING,
 Z STRING);

CREATE OR REPLACE PROCEDURE RUNEMAILER
	(V VARCHAR2,
	 W VARCHAR2,
 	 X VARCHAR2,
 	 Y VARCHAR2,
 	 Z VARCHAR2)
IS
	V_SENDER VARCHAR2(40)  := V;
	V_REC VARCHAR2(40)     := W;
	V_HOST VARCHAR2(40)    := X;	-- The name of your mail server
	V_SUBJECT VARCHAR2(60) := Y;
	V_BODY VARCHAR2(4000)    := Z; 	-- This can be sized lower if desired - R
	BEGIN
	Emailer(V_SENDER, V_REC, V_HOST, V_SUBJECT, V_BODY);
END;
/
SHOW ERRORS

-- Sample of the implementation
-- EXECUTE runemailer('brudolf', 'brudolf@pcs.com', 'mailserver.pcs.com', 'test', 'test message');
