CREATE OR REPLACE PROCEDURE test_emplu (
   counter IN INTEGER
  ,employee_id_in IN employees.employee_id%TYPE := 137
)
IS
   emprec   employees%ROWTYPE;
BEGIN
   PLVtmr.set_factor (counter);
   PLVtmr.capture;

   FOR i IN 1 .. counter
   LOOP
      emprec := emplu1.onerow (employee_id_in);
   END LOOP;

   PLVtmr.show_elapsed ('database table');
   --
   PLVtmr.set_factor (counter);
   PLVtmr.capture;

   FOR i IN 1 .. counter
   LOOP
      emprec := emplu2.onerow (employee_id_in);
   END LOOP;

   PLVtmr.show_elapsed ('associative array');
   PLVtmr.set_factor (counter);
   PLVtmr.capture;

   FOR i IN 1 .. counter
   LOOP
      emprec := emplu2.onerow_incremental (employee_id_in);
   END LOOP;

   PLVtmr.show_elapsed ('JIT index-by table');
   PLVtmr.set_factor (counter);
   PLVtmr.capture;

   FOR i IN 1 .. counter
   LOOP
      emprec := emplu3.onerow (employee_id_in);
   END LOOP;

   PLVtmr.show_elapsed ('associative array with bulk collect');
   PLVtmr.set_factor (counter);
   PLVtmr.capture;

   FOR i IN 1 .. counter
   LOOP
      emprec := emplu3.onerow ('Vargas');
   END LOOP;

   PLVtmr.show_elapsed ('string-indexed associative array with bulk collect');
/*
database table Elapsed: 5.07 seconds. Factored: .00005 seconds.
associative array Elapsed: .22 seconds. Factored: 0 seconds.
JIT index-by table Elapsed: .34 seconds. Factored: 0 seconds.
Loaded into temporary cache = 11449
associative array with bulk collect Elapsed: .24 seconds. Factored: 0 seconds.
string-indexed associative array with bulk collect Elapsed: .15 seconds. Factored: 0 seconds.
*/
END;
/
