CREATE OR REPLACE PACKAGE analysis
IS 
   FUNCTION caseload (emp_in IN NUMBER)
      RETURN INTEGER;

   FUNCTION avg_cases (dept_in IN NUMBER)
      RETURN INTEGER;
END analysis;
/


CREATE OR REPLACE PACKAGE BODY analysis
IS 
   FUNCTION caseload (emp_in IN NUMBER)
      RETURN INTEGER
   IS
   BEGIN
      RETURN 1;
   END;

   FUNCTION avg_cases (dept_in IN NUMBER)
      RETURN INTEGER
   IS
   BEGIN
      RETURN 1;
   END;
END analysis;
/


CREATE OR REPLACE PROCEDURE assign_workload (department_in IN NUMBER)
IS 
   case# INTEGER;
   
   CURSOR emps_in_dept_cur
   IS
      SELECT *
        FROM emp
       WHERE deptno = department_in;

   PROCEDURE assign_next_open_case (emp_id_in IN NUMBER, case_out OUT NUMBER)
   IS
   BEGIN
      /* All that logic goes here... */
      NULL;
   END;

   FUNCTION next_appointment (case_id_in IN NUMBER)
      RETURN DATE
   IS
   BEGIN
      RETURN SYSDATE;
   END;

   PROCEDURE schedule_case (case_in IN NUMBER, date_in IN DATE)
   IS
   BEGIN
      IF case_in IS NOT NULL AND date_in > SYSDATE
      THEN
         /* Do stuff here. */
         NULL;
      END IF;
   END;
BEGIN   /* main */
   FOR emp_rec IN emps_in_dept_cur
   LOOP
      IF analysis.caseload (emp_rec.empno) <
         analysis.avg_cases (department_in)
      THEN
         assign_next_open_case (emp_rec.empno, case#);
         schedule_case (case#, next_appointment (case#));
      END IF;
   END LOOP;
END assign_workload;
/






