-- Cannot query from triggering table...

CREATE OR REPLACE TRIGGER isit_mutating
   AFTER INSERT OR UPDATE
   ON emp
   FOR EACH ROW
DECLARE
   myval   NUMBER;
BEGIN
   SELECT COUNT (*)
     INTO myval
     FROM emp;
END;
/
UPDATE emp
   SET sal = 1000;

ROLLBACK ;

-- Now with autonomous transaction?

CREATE OR REPLACE TRIGGER isit_mutating
   AFTER INSERT OR UPDATE
   ON emp
   FOR EACH ROW
DECLARE
   PRAGMA AUTONOMOUS_TRANSACTION;
   myval   NUMBER;
BEGIN
   SELECT COUNT (*)
     INTO myval
     FROM emp;
END;
/
UPDATE emp
   SET sal = 1000;

ROLLBACK ;

-- Cannot change the triggering table...

CREATE OR REPLACE TRIGGER isit_mutating
   AFTER INSERT OR UPDATE
   ON emp
   FOR EACH ROW
DECLARE
   myval   NUMBER;
BEGIN
   UPDATE emp SET ename = 'Steven' WHERE deptno = 10;
END;
/
UPDATE emp
   SET sal = 1000
   WHERE deptno = 20;

ROLLBACK ;

-- With auton transaction, get a deadlock error...

CREATE OR REPLACE TRIGGER isit_mutating
   AFTER INSERT OR UPDATE
   ON emp
   FOR EACH ROW
DECLARE
   PRAGMA AUTONOMOUS_TRANSACTION;
   myval   NUMBER;
BEGIN
   DELETE FROM emp;
END;
/
UPDATE emp
   SET sal = 1000;

ROLLBACK ;

DROP TRIGGER isit_mutating;
