DECLARE
/* Displays the lines of code in a routine that were never executed.
   You must first run the program unit through the profiler with
   a block something like this:
   
   BEGIN
      p.l (DBMS_PROFILER.START_PROFILER ('run name'));
      your_code_here;
      p.l (DBMS_PROFILER.STOP_PROFILER);
   END;   
*/   
  CURSOR lines_cur (nm IN VARCHAR2)
  IS
      SELECT owner, name, line
        FROM ALL_SOURCE
       WHERE name LIKE UPPER (nm)
        MINUS
      SELECT unit_owner, unit_name, p1.line#
        FROM     
          plsql_profiler_data p1,
          plsql_profiler_units p2
       WHERE
          p1.runID = p2.runid and
          p2.unit_number=p1.unit_number and
          p2.unit_name LIKE UPPER (nm);

   v_text ALL_SOURCE.TEXT%TYPE;         
BEGIN
   p.l ('Code in "&&firstparm" that was not run');
   
   FOR rec IN lines_cur ('&&firstparm')
   LOOP
      SELECT text INTO v_text
        FROM ALL_SOURCE
       WHERE owner = rec.owner
         AND name = rec.name
         AND line = rec.line;
      IF (RTRIM (v_text) IS NOT NULL)
      THEN
         p.l (RTRIM (v_text, CHR(10)));
      END IF;
   END LOOP;
END;
/   

  