CREATE OR REPLACE PACKAGE plsql_limits
IS
   -- There's only way to declare these...
   TYPE weak_ref_cursor IS REF CURSOR;
 
    -- Maximum size for VARCHAR2 in PL/SQL
   SUBTYPE maxvarchar2 IS VARCHAR2 (32767);
 
    -- Maximum size for VARCHAR2 in database (8i and above)
   SUBTYPE dbmaxvarchar2 IS VARCHAR2 (4000);
 
    -- Maximum size of Oracle Developer GLOBAL variable
   SUBTYPE odev_global_variable IS VARCHAR2 (255);
 
    -- Maximum size of Oracle identifier
    -- Prague May 2006
   max_identifier_length CONSTANT PLS_INTEGER := $$max_id_length;
   SUBTYPE identifier IS VARCHAR2 ($$max_id_length);
 
    -- Maximum and minimum BINARY_ and PLS_INTEGER values
   max_pls_integer CONSTANT PLS_INTEGER := POWER (2, 31) - 1;
   min_pls_integer CONSTANT PLS_INTEGER := -1 * POWER (2, 31) + 1;
 
    -- Maximum number of columns in table
   max_columns CONSTANT PLS_INTEGER := 1000;
END plsql_limits;
/
 
