CREATE OR REPLACE PACKAGE tmr
IS
   PROCEDURE capture;

   PROCEDURE show_elapsed;
END tmr;
/

CREATE OR REPLACE PACKAGE BODY tmr
IS
   last_timing   NUMBER := NULL;

   PROCEDURE capture
   IS
   BEGIN
      last_timing := DBMS_UTILITY.get_time;
   END;

   PROCEDURE show_elapsed
   IS
   BEGIN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.get_time - last_timing);
   END;
END tmr;
/

CREATE OR REPLACE PROCEDURE show_birthdays (second_row IN INTEGER)
IS
   TYPE dates_tt IS TABLE OF DATE
      INDEX BY BINARY_INTEGER;

   birthdays   dates_tt;
   v_row       PLS_INTEGER;
BEGIN
   birthdays (1) := '20-mar-72';
   birthdays (second_row) := '01-oct-86';

   FOR rowind IN birthdays.FIRST .. birthdays.LAST
   LOOP
      DBMS_OUTPUT.put_line (birthdays (rowind));
   END LOOP;

   tmr.capture;

   IF birthdays.COUNT > 0
   THEN
      FOR rowind IN birthdays.FIRST .. birthdays.LAST
      LOOP
         IF birthdays.EXISTS (rowind)
         THEN
            DBMS_OUTPUT.put_line (birthdays (rowind));
         END IF;
      END LOOP;
   END IF;

   tmr.show_elapsed;
   tmr.capture;

   FOR rowind IN NVL (birthdays.FIRST, 0) .. NVL (birthdays.LAST, -1)
   LOOP
      BEGIN
         DBMS_OUTPUT.put_line (birthdays (rowind));
      EXCEPTION
         WHEN NO_DATA_FOUND
         THEN
            NULL;
      END;
   END LOOP;

   tmr.show_elapsed;
   tmr.capture;
   v_row := birthdays.FIRST;

   WHILE (v_row IS NOT NULL)
   LOOP
      DBMS_OUTPUT.put_line (birthdays (v_row));
      v_row := birthdays.NEXT (v_row);
   END LOOP;

   tmr.show_elapsed;
END;
/