CREATE TABLE UnionBuster (
   ub_id INTEGER,
   labor_type VARCHAR2(100),
   hourly_wage INTEGER);

CREATE INDEX ub_lt ON unionbuster (labor_type);

CREATE SEQUENCE ub_seq;

DECLARE
   rec UnionBuster%ROWTYPE;
   ins_sel_tmr tmr_t := tmr_t.make ('INSERT-SELECT', 10000);
   returning_tmr tmr_t := tmr_t.make ('RETURNING', 10000);
BEGIN
   ins_sel_tmr.GO;
   FOR indx IN 1 .. 10000
   LOOP
      INSERT INTO UnionBuster VALUES (ub_seq.NEXTVAL, 'Prison'||indx, 5);
      SELECT ub_id, hourly_wage INTO rec.ub_id, rec.hourly_wage
        FROM UnionBuster
       WHERE labor_type = 'Prison'||indx;
   END LOOP;
   ins_sel_tmr.STOP;

   ROLLBACK;

   returning_tmr.GO;
   FOR indx IN 1 .. 10000
   LOOP
      INSERT INTO UnionBuster VALUES (ub_seq.NEXTVAL, 'Prison'||indx, 5)
         RETURNING ub_id, hourly_wage INTO rec.ub_id, rec.hourly_wage;
   END LOOP;
   returning_tmr.STOP;

   ROLLBACK;  
END;
/

DROP TABLE UnionBuster;
DROP SEQUENCE ub_seq;
