DROP TABLE otn_question;

CREATE TABLE otn_question (
   title VARCHAR2(100),
   description VARCHAR2(2000));

INSERT INTO otn_question VALUES ('Use implicit?', 'How can I access SQL% cursor attributes inside a cursor FOR loop with an implicit cursor');

INSERT INTO otn_question VALUES ('Use explicit?', 'How can I access cursor attributes inside a cursor FOR loop with an explicit cursor?');

BEGIN
   DBMS_OUTPUT.put_line ('SQL%ROWCOUNT inside CFL?');
   FOR rec IN (SELECT * FROM otn_question)
   LOOP
      DBMS_OUTPUT.put_line ('   SQL%ROWCOUNT = ' || NVL (TO_CHAR(SQL%ROWCOUNT), 'NULL'));
   END LOOP;
END;
/

BEGIN
   UPDATE otn_question SET description = UPPER (description);
   DBMS_OUTPUT.put_line ('SQL%ROWCOUNT after update, before CFL = '||SQL%ROWCOUNT);
   FOR rec IN (SELECT * FROM otn_question)
   LOOP
      DBMS_OUTPUT.put_line ('   SQL%ROWCOUNT = ' || NVL (TO_CHAR(SQL%ROWCOUNT), 'NULL'));
   END LOOP;
   DBMS_OUTPUT.put_line ('SQL%ROWCOUNT after update, after CFL = '||SQL%ROWCOUNT);
END;
/

DECLARE
   CURSOR otn_question_cur
   IS
      SELECT *
        FROM otn_question;
BEGIN
   DBMS_OUTPUT.put_line ('otn_question_cur%ROWCOUNT inside CFL');
   FOR rec IN otn_question_cur
   LOOP
      DBMS_OUTPUT.put_line ('   otn_question_cur%ROWCOUNT = ' || NVL (TO_CHAR(otn_question_cur%ROWCOUNT), 'NULL'));
   END LOOP;
END;
/

DECLARE
   TYPE otn_question_tc IS TABLE OF otn_question%ROWTYPE
      INDEX BY PLS_INTEGER;

   l_otn_questions otn_question_tc;
BEGIN
   DBMS_OUTPUT.put_line ('SQL%ROWCOUNT after BULK COLLECT');
   SELECT *
   BULK COLLECT INTO l_otn_questions
     FROM otn_question;
   DBMS_OUTPUT.put_line ('   SQL%ROWCOUNT = ' || NVL (TO_CHAR(SQL%ROWCOUNT), 'NULL'));
   DBMS_OUTPUT.put_line ('   Collection count = ' || NVL (TO_CHAR(l_otn_questions.COUNT), 'NULL'));
END;
/

DROP TABLE otn_question;